package de.ozgcloud.eingang.fim;

import java.util.List;
import java.util.Map;
import java.util.Optional;

import org.springframework.stereotype.Component;

import de.ozgcloud.eingang.common.formdata.FormData;
import lombok.RequiredArgsConstructor;
import lombok.extern.log4j.Log4j2;

@Log4j2
@RequiredArgsConstructor
@Component
class HeaderMapper implements FimEngineBasedMapper {

	static final String FORM_NAME_KEY = "F05002753";

	@Override
	public FormData parseFormData(FormData formData) {
		return getFormName(formData.getFormData()).map(formName -> addFormName(formData, formName)).orElse(formData);
	}

	Optional<String> getFormName(Map<String, Object> formData) {
		return FimDataUtil.getValue(formData, List.of("G17003529", "G05001479", "G05001480"), FORM_NAME_KEY);
	}

	private FormData addFormName(FormData formData, String formName) {
		return formData.toBuilder()
				.header(formData.getHeader().toBuilder()
						.formName(formName)
						.build())
				.build();
	}
}