package de.ozgcloud.eingang.semantik.common;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.ozgcloud.eingang.common.formdata.FormData;

public class FormDataTestFactory {
	public static final String POSTFACH_NAME_ID = "name-id-value";
	public static final int REST_RESPONSE_NAME_MEMBER_SCOPE_MAILBOX_TYPE_VALUE = 1;

	public static FormData create() {
		return createBuilder().build();
	}

	public static FormData.FormDataBuilder createBuilder() {
		return FormData.builder().formData(createFormDataMap());
	}

	public static Map<String, Object> createFormDataMap() {
		var map = new HashMap<String, Object>();
		map.put(POSTFACH_NAME_ID, POSTFACH_NAME_ID);
		map.put(ServiceKontoFactory.REST_RESPONSE_NAME, List.of(createRestResponseNameMap()));

		return map;
	}

	public static Map<String, Object> createRestResponseNameMap() {
		return Map.of(ServiceKontoFactory.REST_RESPONSE_NAME_MEMBER_SCOPE, List.of(createRestResponseNameMemberScopeMap()));
	}

	private static Map<String, Object> createRestResponseNameMemberScopeMap() {
		return Map.of(ServiceKontoFactory.REST_RESPONSE_NAME_MEMBER_SCOPE_MAILBOX_TYPE, REST_RESPONSE_NAME_MEMBER_SCOPE_MAILBOX_TYPE_VALUE);
	}
}
